;============================================================
;hacks console via cheat table and dword list
;============================================================

;The cheat table is composed of a list of structures composed of two
;members: a pointer to a certain cheat string and the cheat's number
;in the list (starting with 0). The list's terminator is a DWORD
;showing the number of 8-byte entries in the table. All members of
;default table are kept to point to the in-EXE strings.
;
;After that is a DWORD address list that determines the cheat code
;to jump to during the game

;============================================================

mov edi,[CONSOLECODE_BASE_MOV]
push esi
mov esi,[edi+1] 	;esi=address of cheat table
mov eax,[edi+23]	;list terminator address (number of entries)
mov ecx,[eax]		;get number of entries

mov [TotalCheats],ecx	;unused
mov [OriginalCheats],ecx
mov edi,Cheattable
add ecx,ecx		;2 DWORDs per entry
rep movsd		;copy table to DLL space
;-------------------------------
NumberOfNewCheats   equ (EndNewCheattableMembers-NewCheattableMembers)/8
;-------------------------------
mov ecx,NumberOfNewCheats
add [TotalCheats],ecx
add [eax],ecx		;add total # of cheats in executable's variable in data section
mov esi,NewCheattableMembers
add ecx,ecx		;8 bytes per cheat = * 2
			;edi=end of current table in 'Cheattable'
rep movsd		;copy new cheat entries to current in 'Cheattable'
pop esi

;============================================================
;WRITE NEW CHEAT ID TABLE ADDRESS
;============================================================
mov edi,[CONSOLECODE_BASE_MOV]
add edi,1

_WRITE_EXE edi,CheatTablePTR,4,_message9  ;write new cheat table pointer to MOV instruction

jmp OVERJUMPCODE_HACKCONSOLE
	JUMPTODLLFROMCHEATSCAN:
	jmp [FoundCheatPTR]	;6 bytes
OVERJUMPCODE_HACKCONSOLE:

;============================================================
;WRITE NEW "CHEAT FOUND" JUMP
;============================================================
add edi,44			;points to je destination in EXE

_WRITE_EXE edi,JUMPTODLLFROMCHEATSCAN,6,_message9b ;write new jump for "found valid cheat" code

;============================================================
;COPY AND ADD TO DWORD JUMP LIST
;============================================================
push esi
mov esi,[edi+24]		;base of indexed jump list in EXE
mov eax,[OriginalCheats]
mov ecx,eax
mov edi,CHEATJUMPINDEX
rep movsd			;copy old list to DLL

mov esi,NEWCHEATSINDEX
mov ecx,NumberOfNewCheats
				;edi already set to append to table
rep movsd			;append new members
pop esi
