;===============================================================
;DETECTS CALLING EXECUTABLE AND SETS CURRENT DIRECTORY PATH
;===============================================================

invoke GetModuleFileName,0,StringBuffer,400
	mov [PathStringSize],eax  ;save path length (excluding null-terminator)
	xor ebp,ebp
	test eax,eax
	jnz NoGetModuleFileNameError
	cmp eax,400
	jb NoGetModuleFileNameError
	mov ebp,1
	NoGetModuleFileNameError:
	WRITELOG_WEXIT _message22b

	;open main EXE to get size
	;FILE_SHARE_READ required to get handle, else fails
invoke CreateFile,StringBuffer,GENERIC_READ,FILE_SHARE_READ,\
		0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	mov ebp,1
	cmp eax,-1
	jz GetEXESizeError
	test eax,eax
	jz GetEXESizeError
	xor ebp,ebp

	push eax
invoke GetFileSize,eax,0
	pop ecx
	cmp eax,-1
	jnz NoGetEXESizeError
	mov ebp,1
	NoGetEXESizeError:
		GetEXESizeError:
	WRITELOG_WEXIT _message22c

	push eax
invoke CloseHandle,ecx
	pop eax

cmp eax,_exe_P5_Demo_Size	;detect executable type via file size
	jz SetP5_Demo
cmp eax,_exe_K6_1_1_Size
	jz SetK6_1_1
cmp eax,_exe_P5_1_1_Size
	jz SetP5_1_1
cmp eax,_exe_P6_1_1_Size
	jz SetP6_1_1

mov ebp,1
WRITELOG_WEXIT _message22

SetP6_1_1:			;set proper base data pointer
	mov eax,P6_1_1_Data
	mov [BaseData],eax
	jmp EXESet

SetP5_1_1:
	mov eax,P5_1_1_Data
	mov [BaseData],eax
	jmp EXESet

SetK6_1_1:
	mov eax,K6_1_1_Data
	mov [BaseData],eax
	jmp EXESet

SetP5_Demo:
	mov eax,P5_Demo_Data
	mov [BaseData],eax
EXESet:

WRITELOG_NOFAIL _message22,0
;===============================================================
;uses EXE filename/path in StringBuffer to find current directory

	mov ecx,[PathStringSize]
	xor edx,edx
FindMainTresDirPath:
	cmp BYTE [StringBuffer+ecx],'\'
	jz FoundMainTresDirPath
	loop FindMainTresDirPath
or edx,1
or ecx,0FFFFFFFFh
FoundMainTresDirPath:

WRITELOG _message12,edx

	inc ecx
	mov BYTE [StringBuffer+ecx],0	;set null-terminator to Tres path after '\'
	mov [PathStringSize],ecx	;will point to null-terminator

;===============================================================
;uses previous to find 'MAPS' / copy path

	mov edx,ecx
	mov edi,MapsDirBuffer
	mov esi,StringBuffer
	rep movsb		;move dir path to new location

	mov [edx+MapsDirBuffer],DWORD 'MAPS'
	add edx,4
	mov [edx+MapsDirBuffer],WORD 005Ch	;'\' + null-terminator
	add edx,1
	mov [MapsPathSize],edx			;store size

;===============================================================